% Initialize the hextron
hextron = PopneuronHextron();

% move immediately to an absolute x position 
[hextron, success] = move_x_absolute(hextron, -5);
disp(success);
pause(1);

% move immediately to an absolute y position 
[hextron, success] = move_y_absolute(hextron, -7);
disp(success);
pause(1);

% move immediately to an absolute z position 
[hextron, success] = move_z_absolute(hextron, 8);
disp(success);
pause(1);

% move immediately to an absolute pitch position 
[hextron, success] = move_pitch_absolute(hextron, -6);
disp(success);
pause(1);

% move immediately to an absolute yaw position 
[hextron, success] = move_yaw_absolute(hextron, 2.47);
disp(success);
pause(1);

% move immediately to an absolute roll position 
[hextron, success] = move_roll_absolute(hextron, -4.3);
disp(success);
pause(1);

% read the current positions of the hextron
[x, y, z, pitch, yaw, roll] = get_positions(hextron);
disp(x, y, z, pitch, yaw, roll);


pause(2)


% reset hextron to the center position
[hextron, success] = move_center_position(hextron);
disp(success);
[x, y, z, pitch, yaw, roll] = get_positions(hextron);
disp(x, y, z, pitch, yaw, roll);


pause(2)

% move immediately to absolute positions
[hextron, success] = move_absolute(hextron, -1.2, 3.0, -7.0, 7.3, -2.4, 4.8);
disp(success);
[x, y, z, pitch, yaw, roll] = get_positions(hextron);
disp(x, y, z, pitch, yaw, roll);
pause(2)

% read the current positions of the hextron with individual functions
disp(get_x_position(hextron))
disp(get_y_position(hextron))
disp(get_z_position(hextron))
disp(get_pitch_position(hextron))
disp(get_yaw_position(hextron))
disp(get_roll_position(hextron))

% move immediately to relative positions
[hextron, success] = move_relative(hextron, 7.3, 4.1, 5.0, -1.5, -3.5, -7.9);
disp(success);
[x, y, z, pitch, yaw, roll] = get_positions(hextron);
disp(x, y, z, pitch, yaw, roll);
pause(2)

% Deferred movement to aboslute positions until move_now 
[hextron, success] = move_x_absolute(hextron, -5.2, false);
disp(success);
[hextron, success] = move_z_absolute(hextron, 7.9, false);
disp(success);
[hextron, success] = move_now(hextron);
disp(success);
[x, y, z, pitch, yaw, roll] = get_positions(hextron);
disp(x, y, z, pitch, yaw, roll);

% Deferred movement to relative positions until move_now
[hextron, success] = move_x_relative(hextron, 9.3, false);
disp(success);
[hextron, success] = move_pitch_relative(hextron, -10.3, false);
disp(success);
[hextron, success] = move_now(hextron);
disp(success);
[x, y, z, pitch, yaw, roll] = get_positions(hextron);
disp(x, y, z, pitch, yaw, roll);

% Close the Hextron and release the memory
hextron = []
